package jp.co.gihyo.webdb.vol36.selenium.regression;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.util.Properties;

import org.dbunit.DatabaseTestCase;
import org.dbunit.database.DatabaseConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.xml.FlatXmlDataSet;
import org.openqa.selenium.server.SeleniumServer;

import com.thoughtworks.selenium.DefaultSelenium;
import com.thoughtworks.selenium.Selenium;

public class LoginRegressionTest extends DatabaseTestCase {

	private SeleniumServer server;
	private Selenium selenium;
	private Properties prop;

	public LoginRegressionTest() throws Exception {
		server = new SeleniumServer();
		String bw = "*iexplore";
		String url = "http://localhost:8080";
		selenium = new DefaultSelenium( "localhost", 4444, bw, url );

		prop = new Properties();
		prop.load(new FileInputStream("jdbc.properties"));
	}

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		server.start();
		selenium.start();
	}

	@Override
	protected void tearDown() throws Exception {
		selenium.stop();
		server.stop();
		super.tearDown();
	}

	public void testo^ƃOC̊mF() throws Exception {
		selenium.open( "/login/signup.do" );
		assertEquals( "Login - VKo^", selenium.getTitle() );
		selenium.type( "account.userId", "yamada" );
		selenium.type( "account.password", "tarou" );
		selenium.type( "passwordConfirm", "tarou" );
		selenium.click( "//input[@value='o^']" );
		selenium.waitForPageToLoad( "30000" );
		assertEquals( "Login - o^", selenium.getTitle() );
		selenium.click( "link=" );
		selenium.waitForPageToLoad( "30000" );
		assertEquals( "Login - OC", selenium.getTitle() );
		selenium.type( "account.userId", "yamada" );
		selenium.type( "account.password", "tarou" );
		selenium.click( "//input[@value='OC']" );
		selenium.waitForPageToLoad( "30000" );
		assertEquals( "Login - OC", selenium.getTitle() );
	}

	public void testo^̏ꍇ() throws Exception {
		selenium.open( "/login/login.do" );
		assertEquals( "Login - OC", selenium.getTitle() );
		selenium.type( "account.userId", "yamada" );
		selenium.type( "account.password", "tarou" );
		selenium.click( "//input[@value='OC']" );
		assertTrue( selenium.isTextPresent( "[U[pX[hԈĂ܂" ) );
		assertEquals( "Login - OC", selenium.getTitle() );
	}

	@Override
	protected IDatabaseConnection getConnection() throws Exception {
		String driverUrl = prop.getProperty("url");
		String user = prop.getProperty("user");
		String pass = prop.getProperty("password");

		Class.forName( "com.mysql.jdbc.Driver" );
		Connection con = DriverManager.getConnection( driverUrl, user, pass );
		return new DatabaseConnection( con );
	}

	@Override
	protected IDataSet getDataSet() throws Exception {
		return new FlatXmlDataSet( new FileInputStream( "testdata/initTable.xml" ) );
	}

}
